-- namespace
local HCL = {}
HCL.name = "HavinsClock"
HCL.version = 1
local CLOCKUI_SCENE_FRAGMENT

------------------
-- defaults
------------------
HCL.defaults = {
    offset = {
        x = 500,
        y = 5,
    }
}

-- on load
function HCL.OnLoad(event, addonName)
    if addonName == HCL.name then
		HCL.settings = ZO_SavedVars:NewAccountWide("HavinsClock_Data", HCL.version, nil, HCL.defaults)
		HCL.Initialize()
    end
end

------------------
-- Save Position
------------------

function HCL_SavePosition()
	HCL.settings.offset.x = HCLUITime:GetLeft()
    HCL.settings.offset.y = HCLUITime:GetTop()
end

------------------
-- Set Time
------------------

function HCL.PrintClock()
    
	local seconds = GetSecondsSinceMidnight()

    -- hour	
	local hour = 0
    while seconds > 3599 do
        hour = hour + 1
        seconds = seconds - 3600
    end
	
    if hour < 10 then
        hZero = "0" .. hour
    else
        hZero = hour
    end

    -- minute	
    local minute = 0
    while seconds > 59 do
        minute = minute + 1
        seconds = seconds - 60
    end

    if minute < 10 then
        mZero = "0" .. minute
    else
        mZero = minute
    end
	
    HCLUITime:SetText(hZero .. ':' .. mZero)
	zo_callLater(function() HCL.PrintClock() end, 60000)
end

-------------------------------------------------
-- INIT (called last)
-------------------------------------------------

function HCL.Initialize()

	-- vanilla
    HCLUITime:SetColor(0.95, 0.90, 0.67, 0.45)
	
	-- http://wiki.esoui.com/Fonts
	local face = ZoFontBookPaper:GetFontInfo()
	local font = ("%s|%s"):format(face, 24)
    HCLUITime:SetFont(font)

	HCLUI:ClearAnchors()
	HCLUI:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, HCL.settings.offset.x, HCL.settings.offset.y)

    HCL.PrintClock()

	EVENT_MANAGER:UnregisterForEvent(HCL.name, EVENT_ADD_ON_LOADED)
end

-------------------------------------------------
-- START
-------------------------------------------------
EVENT_MANAGER:RegisterForEvent(HCL.name, EVENT_ADD_ON_LOADED, HCL.OnLoad)